﻿if(documents.length==0){
   alert("You need to have your file opened")
}else{ 	//if opened

if(activeDocument.mode !=DocumentMode.RGB){ 
   activeDocument.changeMode(ChangeMode.RGB);
}

if (!hasSelection(app.activeDocument)) {
//no selection
try{
Backuped_history_state = activeDocument.activeHistoryState
}
catch(e){}
SaveToTempPlace()
	}
//something selected
else{
	//if rectangular
    if (activeDocument.historyStates[activeDocument.historyStates.length-2] == "[HistoryState Rectangular Marquee]") {
        Backuped_history_state = activeDocument.activeHistoryState
        activeDocument.crop([app.activeDocument.selection.bounds[0], app.activeDocument.selection.bounds[1], app.activeDocument.selection.bounds[2], app.activeDocument.selection.bounds[3]])
        try{
        }
        catch(e){}
        SaveToTempPlace()
        }
    //if not rectangular transparency is needed
    else{
Backuped_history_state = activeDocument.activeHistoryState
activeDocument.flatten()
app.activeDocument.selection.copy();
NewDocumentFromClipboard();
EnlargeCanvas();
DeleteBG();

SaveToTempPlace();
app.activeDocument.close(SaveOptions.DONOTSAVECHANGES);
    }
    }
activeDocument.activeHistoryState = Backuped_history_state


function hasSelection(doc) {
var res = false;
var as = doc.activeHistoryState;
doc.selection.deselect();
if (as != doc.activeHistoryState) {
res = true;
doc.activeHistoryState = as;
}
return res;
}

function NewDocumentFromClipboard() {
var calcWidth  = app.activeDocument.selection.bounds[2] - app.activeDocument.selection.bounds[0];
var calcHeight = app.activeDocument.selection.bounds[3] - app.activeDocument.selection.bounds[1];
var docResolution = app.activeDocument.resolution;
app.activeDocument.selection.copy();
var myNewDoc = app.documents.add(calcWidth, calcHeight, docResolution);
myNewDoc.paste();
}

function EnlargeCanvas() {
var calcWidth  = app.activeDocument.width.value * 1.05;
var calcHeight = app.activeDocument.height.value * 1.05;
app.activeDocument.resizeCanvas(calcWidth, calcHeight, AnchorPosition.MIDDLECENTER);
}

function DeleteBG() {
activeDocument.activeLayer = activeDocument.artLayers[activeDocument.artLayers.length-1]
if (activeDocument.activeLayer.isBackgroundLayer == true){
activeDocument.activeLayer.remove()
}
}

function SaveToTempPlace() {
//Save
SaveTempFile = new File("C:\\PSD_2_MAX_Folder\\PSD_2_MAX.tif");
saveOptions = new TiffSaveOptions();
    saveOptions.transparency = true;
    saveOptions.alphaChannels = true;
    saveOptions.imageCompression = TIFFEncoding.TIFFLZW;
    saveOptions.layers = true;
    saveOptions.byteOrder = ByteOrder.IBM; 
    saveOptions.embedColorProfile = false;
    saveOptions.saveImagePyramid = false;
activeDocument.saveAs(SaveTempFile, saveOptions, true,Extension.LOWERCASE);
	}
}

function selectTransparency() {
function cTID(s) { return app.charIDToTypeID(s); };
  function sTID(s) { return app.stringIDToTypeID(s); };
    var desc27 = new ActionDescriptor();
        var ref3 = new ActionReference();
        ref3.putProperty( cTID('Chnl'), cTID('fsel') );
    desc27.putReference( cTID('null'), ref3 );
        var ref4 = new ActionReference();
        ref4.putEnumerated( cTID('Chnl'), cTID('Chnl'), cTID('Trsp') );
    desc27.putReference( cTID('T   '), ref4 );
    executeAction( cTID('setd'), desc27, DialogModes.NO );
}

function Save_Selection_to_Alpha_Channel() {
var channelRef = activeDocument.channels.add();
var solidColorRef = new SolidColor();
solidColorRef.rgb.red = 255;
solidColorRef.rgb.green = 255;
solidColorRef.rgb.blue = 255;
activeDocument.selection.fill(solidColorRef)
}

function Try_Remove_Alpha_Channel() {
try{
app.activeDocument.channels.getByName("Alpha 1").remove();
}
catch(e){
}
}

function Select_All_Layers() {
var id21 = stringIDToTypeID( "selectAllLayers" );
    var desc3 = new ActionDescriptor();
    var id22 = charIDToTypeID( "null" );
        var ref1 = new ActionReference();
        var id23 = charIDToTypeID( "Lyr " );
        var id24 = charIDToTypeID( "Ordn" );
        var id25 = charIDToTypeID( "Trgt" );
        ref1.putEnumerated( id23, id24, id25 );
    desc3.putReference( id22, ref1 );
executeAction( id21, desc3, DialogModes.NO );
}