macroScript PSD_2_MAX_Selection_Only category:"Xylonite Tools" buttonText:"PSD_2_MAX_Selection_Only" toolTip:"PSD_2_MAX_Selection_Only"
(

CurrentFileName = getFilenameFile maxfilename;
if CurrentFileName == "" then (
	messageBox "SAVE FILE to the scenes folder first"
	)
else
(

with redraw off 
(

MapsFilePath = ("C:\\PSD_2_MAX_Folder" + "\\maps\\");

if ((dotnetclass "System.IO.Directory").exists MapsFilePath) == false then makeDir MapsFilePath;

FileNumber = 1
Flag=0
FileName="PSD_2_MAX_"
BackupMapsFilePath = MapsFilePath + FileName

do
(
	TempMapsFilePath = BackupMapsFilePath + FileNumber as string + ".tif"
	if ((dotnetclass "System.IO.File").exists TempMapsFilePath) == true then (
	FileNumber = FileNumber + 1
	)
	else 	(
		
		Flag = 1
		MapsFilePath = BackupMapsFilePath + FileNumber as string + ".tif"
	)
)
while Flag==0

if (((dotnetclass "System.IO.File").exists ("C:\\PSD_2_MAX_Folder\\PSD_2_MAX.tif")) == true) then
(

--copy temporary file to maps dir
File = dotNetClass "System.IO.File"
File.Copy "C:\\PSD_2_MAX_Folder\\PSD_2_MAX.tif" MapsFilePath

--build material
theMap = openBitMap MapsFilePath
		local theMaterial = StandardMaterial selfIllumAmount:0 
		theMaterial.diffusemap = bitmapTex bitmap:theMap
		theMaterial.diffusemap.coords.blur = 0.01
		showTextureMap theMaterial on	
		if theMap.hasAlpha == true then
		(
		theMaterial.opacityMap = copy theMaterial.diffuseMap
		theMaterial.opacityMap.monoOutput = 1
		theMaterial.opacityMap.coords.blur = 0.01
		)
		theMaterial.name = getFilenameFile MapsFilePath
		
$.material = theMaterial

if subobjectLevel == 4 then
(
modPanel.addModToSelection (Unwrap_UVW ()) ui:on
macros.run "Modifier Stack" "SubObject_3"
$.modifiers[#unwrap_uvw].unwrap5.mappingMode 1
subobjectLevel = 0
)
)
else
(
	messageBox "No file found.\nRun PSD_2_MAX in Adobe Photoshop first"
)

)
) 
)
